	include	"flib.h"
	include	"hexlib.h"
	include	"tios.h"
	include	"irlib.h"
	xdef	_main
	xdef	_comment
;*********************************************************************
SetFont	macro
	move.w	\1,-(a7)
	jsr	tios::FontSetSys
	lea	2(a7),a7
	endm
WriteStr	macro
	move.w	\3,-(a7)
	pea	\4(pc)
	move.w	\2,-(a7)
	move.w	\1,-(a7)
	jsr	tios::DrawStrXY
	lea	10(a7),a7
	endm
;*********************************************************************
_main:
	clr	d5
	clr	d6
	jsr	flib::zap_screen
	SetFont	#2
	WriteStr	#0,#0,#1,Text1
	WriteStr	#0,#10,#1,Text2
	WriteStr	#0,#20,#1,Text3
	WriteStr	#0,#30,#1,Text4
	WriteStr	#0,#40,#1,Text5
Loop:
	move.l #4,d1
	move.l #12,d2
	move.l #1,d4
	move.l d5,d3
	bsr Affdec

	move.l #5,d1
	move.l #11,d2
	move.l #2,d4
	move.l d6,d3
	bsr Affdec

	jsr		flib::idle_loop
	cmp		#344,d0				; down
	beq		dec_app
	cmp		#338,d0				; up
	beq		inc_app
	cmp		#337,d0				; left
	beq		dec_code
	cmp		#340,d0				; right
	beq		inc_code
	cmp		#257,d0				; del
	beq		send_code
	cmp		#264,d0				; exit
	beq		Exit
	bra		Loop
dec_app:
	cmp.b	#0,d5
	beq		Loop
	sub.b	#1,d5
	bra		Loop
inc_app:
	cmp.b	#31,d5
	beq		Loop
	add.b	#1,d5
	bra		Loop
dec_code:
	cmp.b	#0,d6
	beq		Loop
	sub.b	#1,d6
	bra		Loop
inc_code:
	cmp.b	#127,d6
	beq		Loop
	add.b	#1,d6
	bra		Loop
Exit:
	jsr		tios::reset_link
	rts
;*********************************************************************
;************* Routine pour convertir la commande en RC5 *************
;*********************************************************************
; d0 : sortie
; d5 : appareil
; d6 : commande
; d7 : intermdiaire
send_code:
	clr.w d7
	rol.b #6,d6		; decalage a gauche de 7 de la commande
	or.b d6,d7
	rol.b #2,d6		; on retrouve la commande
	lsl.w #8,d7		; decale pour laisser place a l'appareil
	rol.b #4,d5		; decalage a gauche de 4 de l'appareil
	or.b d5,d7
	ror.b #4,d5		; on retrouve l'appareil
	or #14,d7
	clr.l d0
	move.b #16,d2
Conv:
	lsl.l #2,d0
	btst.w #15,d7
	bne Un
	eori #2,d0
	bra suite
Un:
	eori #1,d0
suite:
	lsl.w #1,d7
	sub.w #1,d2
	cmp.w #0,d2
	bne Conv
	eor.l #$0A000000,d0
	cmp.b #63,d6
	ble pasetendu			; inf ou =
	eor.l #%110000,d0
pasetendu:
	move.l	Philips,d3
	move.w	#31,d4
	jsr		irlib::PutLink
	move.l	d0,d3
	move.w	#31,d4
	jsr		irlib::PutLink
	bra		Loop
;*********************************************************************
; d1 : ligne
; d2 : colone
; d3 : nombre
; d4 : nombre de chiffres-1  afficher
; d0 : intermdiaire
;
; Thanks for Sami Khawam for this routine.
;
Affdec
	clr d0
Convert2BCD
	subi.b	#10,d3
	bcs		IVCont
	addi.b	#$10,d0
	bra		Convert2BCD
IVCont
	addi.b	#10,d3
	or.b	d3,d0
	jsr		hexlib::put_hex
	rts
;*********************************************************************
Text1:	dc.b	"Appareil : Up/Down",0
Text2:	dc.b	"Commande : Left/Right",0
Text3:	dc.b	"Send     : Del",0
Text4:	dc.b	"Appareil : ",0
Text5:	dc.b	"Commande : ",0
Philips:	dc.l	%00010010000011100010000000000100
_comment	dc.b	"v2.0 by A.MERCIER",0
	end
